--- cmake/FindIconv.cmake.orig	2014-02-13 15:09:35 UTC
+++ cmake/FindIconv.cmake
@@ -33,39 +33,24 @@ IF(ICONV_FOUND)
    set(ICONV_FIND_QUIETLY TRUE)
 ENDIF(ICONV_FOUND)
 
-INCLUDE(CheckLibraryExists)
 INCLUDE(CheckFunctionExists)
 
-FIND_PATH(ICONV_INCLUDE_PATH
-  NAMES iconv.h
-  PATHS /usr/include /usr/local/include /usr/pkg/include
-)
-
-FIND_LIBRARY(ICONV_LIBRARY
-  NAMES iconv
-  PATHS /lib /usr/lib /usr/local/lib /usr/pkg/lib
-)
+FIND_PATH(ICONV_INCLUDE_PATH iconv.h)
 
 IF(ICONV_INCLUDE_PATH)
-  IF(ICONV_LIBRARY)
-    STRING(REGEX REPLACE "/[^/]*$" "" ICONV_LIB_PATH "${ICONV_LIBRARY}")
-    CHECK_LIBRARY_EXISTS(iconv libiconv_open ${ICONV_LIB_PATH} LIBICONV_OPEN_FOUND)
-    CHECK_LIBRARY_EXISTS(iconv iconv_open ${ICONV_LIB_PATH} ICONV_OPEN_FOUND)
-    IF(LIBICONV_OPEN_FOUND OR ICONV_OPEN_FOUND)
-       SET(ICONV_FOUND TRUE)
-    ENDIF(LIBICONV_OPEN_FOUND OR ICONV_OPEN_FOUND)
-  ELSE(ICONV_LIBRARY)
-    CHECK_FUNCTION_EXISTS(iconv_open ICONV_FOUND)
-  ENDIF(ICONV_LIBRARY)
+  CHECK_FUNCTION_EXISTS(iconv ICONV_FOUND)
+  IF(NOT ICONV_FOUND)
+    FIND_LIBRARY(ICONV_LIBRARY NAMES iconv libiconv libiconv-2)
+    IF(ICONV_LIBRARY)
+      SET(ICONV_FOUND TRUE)
+    ENDIF(ICONV_LIBRARY)
+  ENDIF(NOT ICONV_FOUND)
 ENDIF(ICONV_INCLUDE_PATH)
 
 include(CheckCSourceCompiles)
 
-IF(ICONV_LIBRARY)
-  SET(CMAKE_REQUIRED_LIBRARIES ${ICONV_LIBRARY})
-  SET(CMAKE_REQUIRED_INCLUDES ${ICONV_INCLUDE_PATH})
-ENDIF(ICONV_LIBRARY)
-
+SET(CMAKE_REQUIRED_LIBRARIES ${ICONV_LIBRARY})
+SET(CMAKE_REQUIRED_INCLUDES ${ICONV_INCLUDE_PATH})
 SET(CMAKE_REQUIRED_FLAGS -Werror)
 check_c_source_compiles("
   #include <iconv.h>
@@ -79,6 +64,10 @@ check_c_source_compiles("
     return 0;
   }
 " ICONV_2ARG_IS_CONST)
+SET(CMAKE_REQUIRED_LIBRARIES)
+SET(CMAKE_REQUIRED_INCLUDES)
+SET(CMAKE_REQUIRED_FLAGS)
+
 MARK_AS_ADVANCED(
   ICONV_INCLUDE_PATH
   ICONV_LIBRARY
